/**
 * @author shilen
 * $Id: PITAttributeDefDAO.java 7361 2011-06-03 20:02:31Z shilen $
 */
package edu.internet2.middleware.grouper.internal.dao;

import java.sql.Timestamp;
import java.util.Set;

import edu.internet2.middleware.grouper.attr.AttributeDef;
import edu.internet2.middleware.grouper.pit.PITAttributeDef;

/**
 * 
 */
public interface PITAttributeDefDAO extends GrouperDAO {

  /**
   * insert or update
   * @param pitAttributeDef
   */
  public void saveOrUpdate(PITAttributeDef pitAttributeDef);
  
  /**
   * insert or update
   * @param pitAttributeDefs
   */
  public void saveOrUpdate(Set<PITAttributeDef> pitAttributeDefs);
  
  /**
   * delete
   * @param pitAttributeDef
   */
  public void delete(PITAttributeDef pitAttributeDef);
  
  /**
   * @param pitAttributeDefId
   * @return pit attribute def
   */
  public PITAttributeDef findById(String pitAttributeDefId);
  
  /**
   * @param name
   * @param orderByStartTime
   * @return set of pit attribute defs
   */
  public Set<PITAttributeDef> findByName(String name, boolean orderByStartTime);
  
  /**
   * Delete records that ended before the given date.
   * @param time
   */
  public void deleteInactiveRecords(Timestamp time);
  
  /**
   * @param id
   * @return set of PITAttributeDef
   */
  public Set<PITAttributeDef> findByStemId(String id);
  
  /**
   * @return active attribute defs that are missing in point in time
   */
  public Set<AttributeDef> findMissingActivePITAttributeDefs();
  
  /**
   * @return active point in time attribute defs that should be inactive
   */
  public Set<PITAttributeDef> findMissingInactivePITAttributeDefs();
}
